package com.jfbrother;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

@Configuration
@EnableSwagger2
public class Swagger2 {

    @Bean
    public Docket createRestApi() {
        return new Docket(DocumentationType.SWAGGER_2)
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.jfbrother.controller"))
                .paths(PathSelectors.any())
                .build();
    }

    private ApiInfo apiInfo() {
        return new ApiInfoBuilder()
                .title("杰夫兄弟流程引擎APIS")
                .description("更多应用，请关注浙江杰夫兄弟智慧科技有限公司(<a href='http://www.jfbrother.com/' target='_blank'>www.jfbrother.com</a>)")
                .termsOfServiceUrl("http://www.jfbrother.com/")
                .contact("luosz@jfbrother.com")
                .version("1.0")
                .build();
    }

}
