package com.jfbrother.common;

/**
 * 常用系统状态码
 * 
 * @author luosz
 *
 */
public enum CommonStatus {
	OK(0, "操作成功"), EXCEPTION(1, "服务器内部异常"), FORBIDDEN(2, "权限不足"), OTHER(3, "其他");
	private int code;
	private String text;

	private CommonStatus(int code, String text) {
		this.code = code;
		this.text = text;
	}

	public int getCode() {
		return code;
	}

	public String getText() {
		return text;
	}

	@Override
	public String toString() {
		return getText();
	}

}
