package com.jfbrother.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import com.jfbrother.model.CgformHeadView;
import com.jfbrother.service.CgformHeadService;
import com.jfbrother.util.map.AjaxJson;
import com.jfbrother.util.map.DataGrid;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

@Api(value = "TableController", description = "自定义表单方法集合")
@Controller
@RequestMapping("/table")
public class TableController extends BaseController {
	@Autowired
	private CgformHeadService cgformHeadService;

	@ApiOperation(value = "表单首页面", notes = "")
	@RequestMapping(value = { "index" }, method = RequestMethod.GET)
	public String index() {
		return "table/index";
	}
	
	@ApiOperation(value = "表单模板设置页面", notes = "")
	@RequestMapping(value = { "modelsIndex" }, method = RequestMethod.GET)
	public String modelsIndex() {
		return "table/modelsIndex";
	}

	@ApiOperation(value = "表单数据列表加载-datagrid", notes = "")
	@ApiImplicitParams({ 
		@ApiImplicitParam(name = "page", value = "显示第几页", required = false, dataType = "int",paramType="form"),
		@ApiImplicitParam(name = "rows", value = "每页显示多少行", required = false, dataType = "int",paramType="form"),
		@ApiImplicitParam(name = "tableName", value = "要搜索的表名，模糊查询", required = false, dataType = "string",paramType="form"),
		@ApiImplicitParam(name = "content", value = "要搜索的表的描述，模糊查询", required = false, dataType = "string",paramType="form"),
		@ApiImplicitParam(name = "isDbsynch", value = "是否已同步数据库（Y:是,N:否）", required = false, dataType = "string",paramType="form")})
	@ResponseBody
	@RequestMapping(value = { "datagrid" }, method = RequestMethod.POST)
	public DataGrid<CgformHeadView> datagrid() {
		return cgformHeadService.datagrid(receiveParams("tableName","content","isDbsynch"));
	}
	
	@ApiOperation(value = "表单数据列表加载-list", notes = "")
	@ApiImplicitParams({ 
		})
	@ResponseBody
	@RequestMapping(value = { "list" }, method = RequestMethod.GET)
	public AjaxJson list() {
		AjaxJson aj=new AjaxJson();
		aj.setObj(cgformHeadService.list());
		return aj;
	}
}
