package com.jfbrother.service;

import java.io.InputStream;
import java.util.Map;

import org.activiti.engine.repository.Deployment;
import org.activiti.engine.repository.Model;
import org.activiti.engine.repository.ProcessDefinition;

import com.jfbrother.model.ProcDefinition;
import com.jfbrother.model.ProcDefinitionView;
import com.jfbrother.util.map.DataGrid;

public interface ProcDefinitionService {
	DataGrid<ProcDefinitionView> datagrid(Map<String, Object> params);

	int save(ProcDefinition procDefinition);

	/**
	 * 创建model
	 * 
	 * @param procId
	 *            流程表id
	 * @param modelName
	 * @param modelKey
	 * @return
	 */
	Model createModel(String procId, String modelName, String description, String modelKey);

	DataGrid<Model> datagridModel(Map<String, Object> params);

	/**
	 * 将模板id为modelId的流程定义部署到该流程，流程之间的版本替换，依据模板中的Process
	 * identifier值（该值来源于流程新建时候的key值）
	 * 
	 * @param procId
	 * @param modelId
	 * @return
	 */
	Deployment deploy(String procId, String modelId);
	
	InputStream viewPic(String deploymentId,StringBuffer imgName);
	
	DataGrid<ProcessDefinition> datagridProcessDefinitionHistroy(Map<String, Object> params);
}
