package com.jfbrother.service.impl;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.jfbrother.dao.CgformHeadMapper;
import com.jfbrother.dao.CgformHeadViewMapper;
import com.jfbrother.model.CgformHead;
import com.jfbrother.model.CgformHeadExample;
import com.jfbrother.model.CgformHeadView;
import com.jfbrother.model.CgformHeadViewExample;
import com.jfbrother.service.CgformHeadService;
import com.jfbrother.util.map.Condition;
import com.jfbrother.util.map.DataGrid;

@Component
public class CgformHeadServiceImpl implements CgformHeadService {

	@Autowired
	private CgformHeadMapper cgformHeadMapper;
	@Autowired
	private CgformHeadViewMapper cgformHeadViewMapper;

	@Override
	public DataGrid<CgformHeadView> datagrid(Map<String, Object> params) {
		DataGrid<CgformHeadView> dg = new DataGrid<CgformHeadView>();
		CgformHeadViewExample example = new CgformHeadViewExample();
		// 添加翻页等通用条件
		Condition.createCondition(params).setCriteriaCurrency(example).setClaszz(CgformHead.class)
			.setCriteriaByAttribute("tableName", Condition.OPTS.Like)
			.setCriteriaByAttribute("content", Condition.OPTS.Like)
			.setCriteriaByAttribute("isDbsynch", Condition.OPTS.EqualTo);
		dg.setRows(cgformHeadViewMapper.selectByExample(example));
		dg.setTotal(cgformHeadViewMapper.countByExample(example));
		return dg;
	}

	@Override
	public List<CgformHead> list() {
		CgformHeadExample example = new CgformHeadExample();
		example.or();
		return cgformHeadMapper.selectByExample(example);
	}

}
