package com.jfbrother.util;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import com.alibaba.fastjson.JSON;

/**
 * 类型转换工具类
 * 
 * @author luosz
 *
 */
public class ConvertUtils {

	/**
	 * 将map类型转化为指定的POJO
	 * 
	 * @param dataMap
	 * @param clazz
	 * @return
	 */
	public static <T> T mapToBean(Map map, Class<T> clazz) {
		String json = JSON.toJSONString(map);
		T t = JSON.parseObject(json, clazz);
		return t;
	}

	/**
	 * 将<String, Object>类型的map转化为<String, String>类型
	 * 
	 * @param dataMap
	 * @return
	 */
	public static Map<String, String> objectToStringByMapValue(Map<String, Object> map) {
		Map<String, String> resultMap = new HashMap<String, String>();
		for (String k : map.keySet()) {
			if (map.get(k) == null) {
				resultMap.put(k, "");
			} else {
				resultMap.put(k, (String) map.get(k));
			}
		}
		return resultMap;
	}
}
