package com.jfbrother.util;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.web.context.request.RequestAttributes;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

/**
 * request工具类
 * 
 * @author luosz
 *
 */
public class RequestUtils {
	/**
	 * HttpServletRequest对象获取
	 * 
	 * @return
	 */
	public static HttpServletRequest getRequest() {
		RequestAttributes requestAttributes = RequestContextHolder.getRequestAttributes();
		if (requestAttributes != null) {
			return ((ServletRequestAttributes) requestAttributes).getRequest();
		}

		return null;
	}

	/**
	 * session对象获取
	 * 
	 * @return
	 */
	public static HttpSession getSession() {
		return getRequest().getSession();
	}

	/**
	 * 指定session名的session对象获取
	 * 
	 * @param sessionName
	 * @return
	 */
	public static Object getSession(String sessionName) {
		return getSession().getAttribute(sessionName);
	}

	/**
	 * 设置session
	 * 
	 * @param sessionName
	 * @param value
	 */
	public static void setSession(String sessionName, Object value) {
		getSession().setAttribute(sessionName, value);
	}
}
