/**
 * easyui  datagrid方法封装
 */
var easyui = {
	datagrid : function(options) {
		var opts = $.extend({
			pagination : true,
			checkOnSelect : false,
			selectOnCheck : false,
			rownumbers : true,
			fitColumns : false,
			striped : true,
			scrollbarSize : 0,
			tableId : options.tableId,
			autoRowHeight : false,
			isSingleSelect : true,
			singleSelect : true,
			//如果需要自定义计算最后一列,则需要设置customLastCellWidth属性为true
			customLastCellWidth : true
		/*,
		border:false*/
		}, options);
		opts.onClickRow = function(rowIndex, rowData) {
			if (typeof options.onClickRow == 'function') {
				options.onClickRow.call(null, rowIndex, rowData);
			}
		//如果用户传入了isSingleSelect属性为true，则设置点击事件时候只能单行选中
		/*if (opts.isSingleSelect) {
			if (typeof datagridSingleSelect == 'function') {
				datagridSingleSelect(opts.tableId, rowIndex);
			}
		}*/
		};

		opts.onRowContextMenu = function(e, rowIndex, rowData) {
			if (typeof options.onRowContextMenu == 'function') {
				options.onRowContextMenu.call(null, e, rowIndex, rowData);
			}
		//如果用户传入了isSingleSelect属性为true，则设置右击事件时候只能单行选中
		/*if (opts.isSingleSelect) {
			datagridSingleSelect(opts.tableId, rowIndex);
		}*/
		}

		opts.onBeforeLoad = function(param) {
			if (typeof options.onBeforeLoad == 'function') {
				options.onBeforeLoad.call(null, param);
			}
			//提交参数前，将每个参数的两边空格都去除
			for (var key in param) {
				param[key] = (param[key] + "").trim();
			}
		};
		opts.onLoadSuccess = function(data) {
			if (typeof options.onLoadSuccess == 'function') {
				options.onLoadSuccess.call();
			}
			//按钮渲染
			if (typeof renderingIconClsList == 'function') {
				renderingIconClsList();
			}
			//如果回传值有checkedIds属性，则将这些id的记录进行勾选操作
			var checkedIds = data.checkedIds;
			if (!stringutil.isEmpty(checkedIds) && checkedIds.length > 0) {
				var rows = data.rows;
				for (var i = 0; i < rows.length; i++) {
					for (var j = 0; j < checkedIds.length; j++) {
						if (checkedIds[j] == rows[i].id) {
							$("#" + opts.tableId).datagrid("checkRow", i);
						}
					}
				}
			}
		};
		return $('#' + opts.tableId).datagrid(opts);
	},
	dialog : function(options) {
		var opts = $.extend({
			modal : true,
			shadow : false
		}, options);

		opts.onClose = function() {
			if (typeof options.onClose == 'function') {
				options.onClose.call();
			}
			$(this).dialog('destroy');
		};
		
		opts.onLoad = function() {
			if (typeof options.onLoad == 'function') {
				options.onLoad.call();
			}
			$.messager.defaults.onClose = function() {};

		//$.messager.progress('close')
		};

		opts.onOpen = function() {
			if (typeof options.onOpen == 'function') {
				options.onOpen.call();
			}

		//数据加载
		/*$.messager.progress({
			text : '数据加载中....',
			interval : 100
		});*/
		};

		if (opts.dialogSelector) {
			//如果是自定义选择器生成dialog，就不需要调用销毁
			opts.onClose = function() {};
			return opts.dialogSelector.dialog(opts);
		} else {
			return $('<div/>').dialog(opts);
		}
	},
	combobox : function(options) {
		if (!options.selector) {
			alert('selector必须设置');
			return;
		}

		var opts = $.extend({
			valueField : 'id',
			textField : 'text',
			defaultEmptyValue : '',
			defaultEmptyText : '-- 请选择 --',
			//空值行是否需要，默认为true，需要
			needEmpty : true
		}, options);

		//如果key，value传进来的属性名一致，则强制改变textField属性名
		var same = false;
		if (opts.valueField == opts.textField) {
			same = true;
			opts.textField = "c_" + opts.textField;
		}

		var responseInfo;
		$.ajax({
			url : opts.url,
			async : false,
			success : function(data) {
				responseInfo = data;
			}
		});

		//设置第一个空行
		var data = [];
		if (opts.needEmpty) {
			var d = {};
			d[opts.valueField] = opts.defaultEmptyValue;
			d[opts.textField] = opts.defaultEmptyText;
			data.push(d);
		}
		var complete_data = responseInfo.obj;
		for (var i = 0; i < complete_data.length; i++) {
			var d = {};
			d[opts.valueField] = complete_data[i][opts.valueField];
			var textFieldName;
			if (same) {
				//如果key，value属性名一致，则获取数据的时候，多了一个"c_"字符，要给予去除
				textFieldName = opts.textField.split("c_")[1];
			} else {
				textFieldName = opts.textField;
			}
			d[opts.textField] = complete_data[i][textFieldName];
			data.push(d);
		}
		
		if (responseInfo.success) {
			if ($(opts.selector).length == 0) {
				alert('selector设置错误');
			}
			opts.data = data;
			delete opts.url;
			var handle = $(opts.selector).combobox(opts);
			return handle;
		}

		return null;
	},
	calendar : function(options) {
		if (!options.selector) {
			alert('selector必须设置');
			return;
		}

		var opts = $.extend({
			current : new Date()
		}, options);

		$(opts.selector).calendar({
			current : new Date()
		});
	},
	datebox : function(options) {
		if (!options.selector) {
			alert('selector必须设置');
			return;
		}

		var opts = $.extend({
			formatter : function(date) {
				var y = date.getFullYear();
				var m = date.getMonth() + 1;
				var d = date.getDate();
				return y + '-' + (m < 10 ? ('0' + m) : m) + '-' + (d < 10 ? ('0' + d) : d);
			}
		}, options);
		$(opts.selector).datebox(opts);
	}
}

/**
 * @author 罗绍泽
 * 
 * @requires jQuery,EasyUI
 * 
 * 防止panel/window/dialog组件超出浏览器边界
 * @param left
 * @param top
 */
var easyuiPanelOnMove = function(left, top) {
  var l = left;
  var t = top;
  if (l < 1) {
    l = 1;
  }
  if (t < 1) {
    t = 1;
  }
  var width = parseInt($(this).parent().css('width')) + 14;
  var height = parseInt($(this).parent().css('height')) + 14;
  var right = l + width;
  var buttom = t + height;
  var browserWidth = $(window).width();
  var browserHeight = $(window).height();
  if (right > browserWidth) {
    l = browserWidth - width;
  }
  if (buttom > browserHeight) {
    t = browserHeight - height;
  }
  $(this).parent().css({ /* 修正面板位置 */
    left : l,
    top : t
  });
};
$.fn.dialog.defaults.onMove = easyuiPanelOnMove;
$.fn.window.defaults.onMove = easyuiPanelOnMove;
$.fn.panel.defaults.onMove = easyuiPanelOnMove;