var stringutil = {
	//判断是否为空
	isEmpty : function(obj) {
		if (obj == null || '' == obj || typeof obj == 'undefined') {
			return true;
		}
		return false;
	},
	//连接数组内的某个属性，按自定义符号分割
	attrConnect : function(array, attrName, sign) {
		if (this.isEmpty(sign)) {
			//默认分割字符为英文逗号
			sign = ",";
		}
		var str = '';
		for (var i = 0; i < array.length; i++) {
			str += sign + array[i][attrName];
		}
		if (str.length > 0) {
			str = str.substr(1);
		}
		return str;
	},
	/**
	 * @author 罗绍泽
	 * 
	 * 增加formatString功能
	 * 
	 * 使用方法：sy.fs('字符串{0}字符串{1}字符串','第一个变量','第二个变量');
	 * 
	 * @returns 格式化后的字符串
	 */
	fs : function(str) {
		for (var i = 0; i < arguments.length - 1; i++) {
			str = str.replace("{" + i + "}", arguments[i + 1]);
		}
		return str;
	},
	toJson : function(str) {
		return eval("(" + str + ")");
	},
	dateToStr : function(formatStr, date) {
		formatStr = arguments[0] || "yyyy-MM-dd HH:mm:ss";
		date = arguments[1] || new Date();
		var str = formatStr;
		var Week = [ '日', '一', '二', '三', '四', '五', '六' ];
		str = str.replace(/yyyy|YYYY/, date.getFullYear());
		str = str.replace(/yy|YY/, (date.getYear() % 100) > 9 ? (date.getYear() % 100).toString() : '0' + (date.getYear() % 100));
		str = str.replace(/MM/, date.getMonth() > 9 ? (date.getMonth() + 1) : '0' + (date.getMonth() + 1));
		str = str.replace(/M/g, date.getMonth());
		str = str.replace(/w|W/g, Week[date.getDay()]);
		str = str.replace(/dd|DD/, date.getDate() > 9 ? date.getDate().toString() : '0' + date.getDate());
		str = str.replace(/d|D/g, date.getDate());
		str = str.replace(/hh|HH/, date.getHours() > 9 ? date.getHours().toString() : '0' + date.getHours());
		str = str.replace(/h|H/g, date.getHours());
		str = str.replace(/mm/, date.getMinutes() > 9 ? date.getMinutes().toString() : '0' + date.getMinutes());
		str = str.replace(/m/g, date.getMinutes());
		str = str.replace(/ss|SS/, date.getSeconds() > 9 ? date.getSeconds().toString() : '0' + date.getSeconds());
		str = str.replace(/s|S/g, date.getSeconds());
		return str;
	},
	longToDateStr :  function(dateVal, formatStr) {
		if(this.isEmpty(dateVal)){
			return "";
		}
		else{
			if(this.isEmpty(formatStr)){
				return this.dateToStr('yyyy-MM-dd',new Date(dateVal));
			}
			else{
				return this.dateToStr(formatStr,new Date(dateVal));
			}
		}	
	},
	uuid:function(){
		var s = [];
		var hexDigits = "0123456789abcdef";
		for (var i = 0; i < 36; i++) {
			s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
		}
		s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
		s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
		s[8] = s[13] = s[18] = s[23] = "-";

		var uuid = s.join("");
		return uuid;
	},
	convertSize:function(size){
		if(size<1024){
			size=size+"B";
		}else if(size>=1024&&size<1024*1024){
			size=(size/1024).toFixed(2) +"KB";
		}else if(size>=1024*1024&&size<1024*1024*1024){
			size=(size/(1024*1024)).toFixed(2)+"MB";
		}else{
			size=(size/(1024*1024*1024)).toFixed(2)+"GB";
		}
		return size;
	},
	/**
	 * @author lyz
	 * 
	 * 比较时间大小
	 */
    compareDate : function(st, et) {
		var d1 = new Date(st.replace(/\-/g, "\/"));
		var d2 = new Date(et.replace(/\-/g, "\/"));
		if (d1 > d2) {
			return true;
		}else{
			return false;
		}
	},
	// 判断某个值是否在数组中
	isCon:function(arr, val) {
		for (var i = 0; i < arr.length; i++) {
			if (arr[i] == val)
				return true;
		}
		return false;
	}
};